package com.zhang.reptile.common.mobile;

package ..deTemp.1730698231285;

import cn.hutool.core.util.StrUtil;
import cn.hutool.core.util.URLUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.zhang.reptile.common.enums.biz.TaskType;
import com.zhang.reptile.common.mobile.AbstractHttpUtils;
import com.zhang.reptile.common.response.ResponseEntity;
import com.zhang.reptile.common.utils.ThreadUtils;
import com.zhang.reptile.common.utils.ToolUtils;
import com.zhang.reptile.system.model.vo.business.FamilyBroadVO;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FamilyBroadHttpUtils extends AbstractHttpUtils {
  private static final Logger log = LoggerFactory.getLogger(com.zhang.reptile.common.mobile.FamilyBroadHttpUtils.class);
  
  public FamilyBroadHttpUtils(String cookies, String proxyIp, String proxyPort, Integer proxySwitch) {
    super(cookies, proxyIp, proxyPort, proxySwitch, TaskType.FAMILY_BROAD);
  }
  
  public ResponseEntity getCustomerInfo(String mobile, String extend, boolean isSave) {
    extend = extend.substring(0, 10);
    List<FamilyBroadVO> list = new ArrayList<>();
    ResponseEntity responseEntity = getCustomerInfo(mobile, extend, list);
    list = matchList(list);
    String result = JSON.toJSONString(list);
    log.info(log("getCustomerInfo", mobile, result));
    if (responseEntity.getIsSuccess().booleanValue())
      return parseList(list, isSave); 
    return responseEntity;
  }
  
  public ResponseEntity getCustomerInfo(String mobile, String extend, List<FamilyBroadVO> list) {
    ResponseEntity responseEntity = logQuery(mobile, extend, 1, list);
    if (responseEntity.getIsSuccess().booleanValue() && 
      list.size() == 10)
      responseEntity = logQuery(mobile, extend, 2, list); 
    if (responseEntity.getIsSuccess().booleanValue()) {
      list = matchList(list);
      for (FamilyBroadVO familyBroadVO : list) {
        ResponseEntity prodChgHis = getProdChgHis(familyBroadVO);
        if (!prodChgHis.getIsSuccess().booleanValue())
          return responseEntity; 
        ThreadUtils.sleep(50L);
      } 
    } 
    return responseEntity;
  }
  
  private List<FamilyBroadVO> matchList(List<FamilyBroadVO> list) {
    List<FamilyBroadVO> dataList = new ArrayList<>();
    for (FamilyBroadVO familyBroadVO : list) {
      if (familyBroadVO.getAcceptType().contains("产品变更") && !familyBroadVO.getState().contains("预生成") && (familyBroadVO
        .getCompany().contains("源创") || familyBroadVO.getCompany().contains("世纪")) && familyBroadVO
        .getFallback().contains("否"))
        dataList.add(familyBroadVO); 
    } 
    return dataList;
  }
  
  public ResponseEntity logQuery(String mobile, String date, int curPage, List<FamilyBroadVO> list) {
    String method = "logQuery";
    try {
      refreshCookies();
      String nowTime = String.valueOf(System.currentTimeMillis());
      String requestUrl = String.format("http://szng.boss.gmcc.net:84/ngcustcare/uniteQuery/logquery/logquery.action?isQueryEvent=0&PageTageDate=%s&logQueryBean.currentPage=%s", new Object[] { nowTime, Integer.valueOf(curPage) });
      Map<String, String> map = new HashMap<>();
      map.put("isQueryEvent", "0");
      map.put("PageTageDate", nowTime);
      map.put("logQueryBean.isExportMadeChgProdDetail", "");
      map.put("logQueryBean.limitExportSize", "");
      map.put("logQueryBean.startDate", date + " 00:00:00");
      map.put("logQueryBean.endDate", date + " 23:59:59");
      map.put("logQueryBean.orgName", "GDYD");
      map.put("logQueryBean.operName", "");
      map.put("operName", "");
      map.put("logQueryBean.recTypeClass", "ALL");
      map.put("logQueryBean.pesRecType", "ALL");
      map.put("logQueryBean.orderType", "");
      map.put("logQueryBean.servNum", mobile);
      map.put("logQueryBean.orderid", "");
      map.put("logQueryBean.accessType", "ALL");
      map.put("logQueryBean.pesCertType", "");
      map.put("logQueryBean.pesCertID", "");
      map.put("logQueryBean.orderStatus", "ALL");
      map.put("logQueryBean.resNoBegin", "");
      map.put("logQueryBean.resNoEnd", "");
      map.put("logQueryBean.payOrg", "");
      map.put("logQueryBean.pesIsIncludeChildOrg", "1");
      map.put("logQueryBean.sort", "");
      map.put("logQueryBean.orderBy", "FORMNUM");
      map.put("moveBackOrderId", "");
      String body = URLUtil.encode(ToolUtils.map2Form(map));
      String result = ((HttpRequest)HttpRequest.post(requestUrl).setProxy(this.proxy).body(body).headerMap(getHeaders(), true)).execute().body();
      if (StrUtil.isNotBlank(result)) {
        if (result.contains("status: 401") || result.contains("会话已经失效，请重新登录"))
          return ResponseEntity.createExpireMsg("4A失效"); 
        Document document = Jsoup.parse(result);
        if (document != null) {
          Element element = document.select("#queryLogTab").first();
          if (element != null) {
            Elements trs = element.select("tr");
            for (int i = 1; i < trs.size() - 1; i++) {
              Elements tds = ((Element)trs.get(i)).select("td");
              if (tds != null && tds.size() > 30) {
                FamilyBroadVO familyBroadVO = new FamilyBroadVO();
                familyBroadVO.setOrderNo(((Element)tds.get(0)).text());
                familyBroadVO.setCustName(((Element)tds.get(2)).text());
                familyBroadVO.setPhone(((Element)tds.get(3)).text());
                familyBroadVO.setProductType(((Element)tds.get(4)).text());
                familyBroadVO.setAcceptType(((Element)tds.get(5)).text());
                familyBroadVO.setBusinessType(((Element)tds.get(6)).text());
                familyBroadVO.setAcceptTime(((Element)tds.get(7)).text());
                familyBroadVO.setOperator(((Element)tds.get(8)).text());
                familyBroadVO.setCompany(((Element)tds.get(9)).text());
                familyBroadVO.setActualMoney(((Element)tds.get(10)).text());
                familyBroadVO.setShareMoney(((Element)tds.get(11)).text());
                familyBroadVO.setState(((Element)tds.get(18)).text());
                familyBroadVO.setFallback(((Element)tds.get(19)).text());
                familyBroadVO.setRemark(((Element)tds.get(20)).select("input").val());
                list.add(familyBroadVO);
              } 
            } 
            return ResponseEntity.createSuccessMsg("查询成功");
          } 
        } 
      } 
      return ResponseEntity.createFailedMsg("查询失败");
    } catch (Exception e) {
      log.error(log(method, mobile, e.getMessage()), e);
      return exception(e);
    } 
  }
  
  private ResponseEntity getProdChgHis(FamilyBroadVO familyBroadVO) {
    String method = "getProdChgHis";
    try {
      String requestUrl = String.format("http://szng.boss.gmcc.net:84/ngcustcare/uniteQuery/logquery/getTabData.action?tabType=ProdChgHis&rectype=ChangeProduct&ordID=%s", new Object[] { familyBroadVO.getOrderNo() });
      String result = ((HttpRequest)HttpRequest.get(requestUrl).setProxy(this.proxy).headerMap(getHeaders(), true)).execute().body();
      if (StrUtil.isNotBlank(result)) {
        if (result.contains("status: 401") || result.contains("会话已经失效，请重新登录"))
          return ResponseEntity.createExpireMsg("4A失效"); 
        Document document = Jsoup.parse(result);
        if (document != null) {
          Elements elements = document.select(".list_tr_bg2color");
          if (elements != null && elements.size() > 0) {
            setProducts(elements, familyBroadVO);
            setProducts2(elements, familyBroadVO);
            return ResponseEntity.createSuccessMsg("查询成功");
          } 
        } 
      } 
      return ResponseEntity.createFailedMsg("查询失败");
    } catch (Exception e) {
      log.error(log(method, familyBroadVO.getOrderNo(), e.getMessage()), e);
      return exception(e);
    } 
  }
  
  private void setProducts2(Elements elements, FamilyBroadVO familyBroadVO) {
    List<String> list2 = new ArrayList<>();
    for (Element element : elements) {
      Elements tds = element.select("td");
      if (tds.size() == 6) {
        String pName = ((Element)tds.get(3)).text();
        if (familyBroadVO.getProductTip().intValue() == 1 && StrUtil.isNotBlank(pName) && pName.equals("装机地址"))
          familyBroadVO.setZjAddress(((Element)tds.get(4)).text()); 
        if ((familyBroadVO.getProductTip().intValue() == 3 || familyBroadVO.getProductTip().intValue() == 4) && 
          StrUtil.isNotBlank(pName) && pName.contains("先装后开产品") && pName.contains("名称"))
          list2.add(((Element)tds.get(4)).text()); 
      } 
    } 
    familyBroadVO.setProducts2(StrUtil.join(",", list2));
  }
  
  private void setProducts(Elements elements, FamilyBroadVO familyBroadVO) {
    List<String> list = new ArrayList<>();
    for (Element element : elements) {
      Elements tds = element.select("td");
      if (tds.size() == 8)
        list.add(((Element)tds.get(1)).text()); 
    } 
    familyBroadVO.setProducts(StrUtil.join(",", list));
    if (familyBroadVO.getProducts().contains("手机宽带")) {
      familyBroadVO.setProductTip(Integer.valueOf(1));
    } else if (familyBroadVO.getProducts().contains("全家低消")) {
      familyBroadVO.setProductTip(Integer.valueOf(2));
    } else if (familyBroadVO.getProducts().contains("全屋WIFI")) {
      familyBroadVO.setProductTip(Integer.valueOf(3));
    } else if (familyBroadVO.getProducts().contains("全屋光网")) {
      familyBroadVO.setProductTip(Integer.valueOf(4));
    } else if (familyBroadVO.getProducts().contains("宽带电视")) {
      familyBroadVO.setProductTip(Integer.valueOf(5));
    } 
  }
  
  private Map<String, String> getHeaders() {
    Map<String, String> headers = new HashMap<>();
    headers.put("Content-Type", "application/x-www-form-urlencoded");
    headers.put("Accept", "application/json, text/plain, */*");
    headers.put("X-Requested-With", "XMLHttpRequest");
    headers.put("Referer", "http://szng.boss.gmcc.net:84/gdbes/resource.root/custsvc/install/gdbes-custsvc-install.html");
    headers.put("Accept-Language", "zh-Hans-CN,zh-Hans;q=0.5");
    headers.put("Accept-Encoding", "gzip, deflate");
    headers.put("User-Agent", "Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko");
    headers.put("Host", "szng.boss.gmcc.net:84");
    headers.put("Cookie", this.cookies);
    return headers;
  }
}
